Mercurial > hg > octave-jordi > gnulib-hg
annotate build-aux/install-reloc @ 11026:f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
author | Bruno Haible <bruno@clisp.org> |
---|---|
date | Sat, 17 Jan 2009 09:29:19 +0100 |
parents | 827a525c7057 |
children | fa0076bdc391 |
rev | line source |
---|---|
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
1 #!/bin/sh |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
2 # install-reloc - install a program including a relocating wrapper |
11026
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
3 # Copyright (C) 2003, 2005-2007, 2009 Free Software Foundation, Inc. |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
4 # Written by Bruno Haible <bruno@clisp.org>, 2003. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
5 # |
9309
bbbbbf4cd1c5
Change copyright notice from GPLv2+ to GPLv3+.
Bruno Haible <bruno@clisp.org>
parents:
9238
diff
changeset
|
6 # This program is free software: you can redistribute it and/or modify |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
7 # it under the terms of the GNU General Public License as published by |
9309
bbbbbf4cd1c5
Change copyright notice from GPLv2+ to GPLv3+.
Bruno Haible <bruno@clisp.org>
parents:
9238
diff
changeset
|
8 # the Free Software Foundation; either version 3 of the License, or |
bbbbbf4cd1c5
Change copyright notice from GPLv2+ to GPLv3+.
Bruno Haible <bruno@clisp.org>
parents:
9238
diff
changeset
|
9 # (at your option) any later version. |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
10 # |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
11 # This program is distributed in the hope that it will be useful, |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
14 # GNU General Public License for more details. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
15 # |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
16 # You should have received a copy of the GNU General Public License |
9309
bbbbbf4cd1c5
Change copyright notice from GPLv2+ to GPLv3+.
Bruno Haible <bruno@clisp.org>
parents:
9238
diff
changeset
|
17 # along with this program. If not, see <http://www.gnu.org/licenses/>. |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
18 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
19 # Usage: |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
20 # install-reloc library_path_var library_path_value prefix destdir \ |
8279 | 21 # compile_command srcdir config_h_dir exeext \ |
22 # install_command... destprog | |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
23 # where |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
24 # - library_path_var is the platform dependent runtime library path variable |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
25 # - library_path_value is a colon separated list of directories that contain |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
26 # the libraries at installation time (use this instead of -rpath) |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
27 # - prefix is the base directory at installation time |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
28 # - destdir is a string that is prepended to all file names at installation |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
29 # time; it is already prepended to destprog but not to library_path_value |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
30 # and prefix |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
31 # - compile_command is a C compiler compilation and linking command |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
32 # - srcdir is the directory where to find relocwrapper.c and its dependencies |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
33 # - builddir is the directory where to find built dependencies (namely, |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
34 # alloca.h and stdbool.h) |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
35 # - config_h_dir is the directory where to find config.h |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
36 # - exeext is platform dependent suffix of executables |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
37 # - install-command is the install command line, excluding the final destprog |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
38 # - destprog is the destination program name |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
39 # install-reloc renames destprog to destprog.bin and installs a relocating |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
40 # wrapper in the place of destprog. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
41 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
42 progname=$0 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
43 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
44 if test $# -eq 2; then |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
45 # Get arguments from environment variables. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
46 library_path_var=$RELOC_LIBRARY_PATH_VAR |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
47 library_path_value=$RELOC_LIBRARY_PATH_VALUE |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
48 prefix=$RELOC_PREFIX |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
49 destdir=$RELOC_DESTDIR |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
50 compile_command=$RELOC_COMPILE_COMMAND |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
51 srcdir=$RELOC_SRCDIR |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
52 builddir=$RELOC_BUILDDIR |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
53 config_h_dir=$RELOC_CONFIG_H_DIR |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
54 exeext=$RELOC_EXEEXT |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
55 install_prog=$RELOC_INSTALL_PROG # including the "-c" option |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
56 else |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
57 if test $# -ge 10; then |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
58 # Get fixed position arguments. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
59 library_path_var=$1 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
60 library_path_value=$2 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
61 prefix=$3 |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
62 destdir=$4 |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
63 compile_command=$5 |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
64 srcdir=$6 |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
65 builddir=$7 |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
66 config_h_dir=$8 |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
67 exeext=$9 |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
68 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
69 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
70 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
71 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
72 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
73 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
74 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
75 shift |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
76 shift |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
77 install_prog=$1 # maybe not including the "-c" option |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
78 shift |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
79 else |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
80 echo "Usage: $0 library_path_var library_path_value prefix destdir" \ |
8279 | 81 "compile_command srcdir builddir config_h_dir exeext" \ |
82 "install_command... destprog" 1>&2 | |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
83 exit 1 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
84 fi |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
85 fi |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
86 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
87 # Get destprog, last argument. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
88 destprog= |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
89 for arg |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
90 do |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
91 destprog=$arg |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
92 done |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
93 # Remove trailing $exeext, if present. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
94 if test -n "$exeext"; then |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
95 sed_quote='s,\.,\\.,g' |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
96 sed_remove_exeext='s|'`echo "$exeext" | sed -e "$sed_quote"`'$||' |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
97 destprog=`echo "$destprog" | sed -e "$sed_remove_exeext"` |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
98 fi |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
99 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
100 # Outputs a command and runs it. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
101 func_verbose () |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
102 { |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
103 echo "$@" |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
104 "$@" |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
105 } |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
106 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
107 # Run install_command. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
108 func_verbose $install_prog "$@" || exit $? |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
109 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
110 # If the platform doesn't support LD_LIBRARY_PATH or similar, we cannot build |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
111 # a wrapper. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
112 test -n "$library_path_var" || exit 0 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
113 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
114 libdirs= |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
115 save_IFS="$IFS"; IFS=":" |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
116 for dir in $library_path_value; do |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
117 IFS="$save_IFS" |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
118 if test -n "$dir"; then |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
119 case "$libdirs" in |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
120 *"\"$dir\""*) ;; # remove duplicate |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
121 *) libdirs="$libdirs\"$dir\"," ;; |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
122 esac |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
123 fi |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
124 done |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
125 IFS="$save_IFS" |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
126 # If there are no library directories to add at runtime, we don't need a |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
127 # wrapper. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
128 test -n "$libdirs" || exit 0 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
129 |
9548
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
130 # Determine installdir from destprog, removing a leading destdir if present. |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
131 installdir=`echo "$destprog" | sed -e 's,/[^/]*$,,'` |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
132 if test -n "$destdir"; then |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
133 sed_quote='s,\([|.\*^$[]\),\\\1,g' |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
134 sed_remove_destdir='s|^'`echo "$destdir" | sed -e "$sed_quote"`'||' |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
135 installdir=`echo "$installdir" | sed -e "$sed_remove_destdir"` |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
136 fi |
827a525c7057
Make --enable-relocatable work with DESTDIR.
Bruno Haible <bruno@clisp.org>
parents:
9547
diff
changeset
|
137 |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
138 # Compile wrapper. |
8279 | 139 func_verbose $compile_command \ |
140 -I"$builddir" -I"$srcdir" -I"$config_h_dir" \ | |
141 -DHAVE_CONFIG_H -DIN_RELOCWRAPPER -DNO_XMALLOC \ | |
142 -D"INSTALLPREFIX=\"$prefix\"" -D"INSTALLDIR=\"$installdir\"" \ | |
143 -D"LIBPATHVAR=\"$library_path_var\"" -D"LIBDIRS=$libdirs" \ | |
144 -D"EXEEXT=\"$exeext\"" \ | |
145 "$srcdir"/relocwrapper.c \ | |
146 "$srcdir"/progname.c \ | |
147 "$srcdir"/progreloc.c \ | |
9238
6d715fbc981c
Change xreadlink module to use areadlink.
Bruno Haible <bruno@clisp.org>
parents:
8950
diff
changeset
|
148 "$srcdir"/areadlink.c \ |
8279 | 149 "$srcdir"/readlink.c \ |
150 "$srcdir"/canonicalize-lgpl.c \ | |
8950
53b90318e324
Update after allocsa -> malloca renaming.
Bruno Haible <bruno@clisp.org>
parents:
8280
diff
changeset
|
151 "$srcdir"/malloca.c \ |
8279 | 152 "$srcdir"/relocatable.c \ |
153 "$srcdir"/setenv.c \ | |
154 "$srcdir"/strerror.c \ | |
155 "$srcdir"/c-ctype.c \ | |
8280
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
156 -o "$destprog.wrapper$exeext" |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
157 rc=$? |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
158 # Clean up object files left over in the current directory by the native C |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
159 # compilers on Solaris, HP-UX, OSF/1, IRIX. |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
160 rm -f relocwrapper.o \ |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
161 progname.o \ |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
162 progreloc.o \ |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
163 xreadlink.o \ |
9238
6d715fbc981c
Change xreadlink module to use areadlink.
Bruno Haible <bruno@clisp.org>
parents:
8950
diff
changeset
|
164 areadlink.o \ |
8280
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
165 canonicalize-lgpl.o \ |
8950
53b90318e324
Update after allocsa -> malloca renaming.
Bruno Haible <bruno@clisp.org>
parents:
8280
diff
changeset
|
166 malloca.o \ |
8280
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
167 relocatable.o \ |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
168 setenv.o \ |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
169 strerror.o \ |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
170 c-ctype.o |
cf9fed416d8c
Avoid leaving object files around.
Bruno Haible <bruno@clisp.org>
parents:
8279
diff
changeset
|
171 test $rc = 0 || exit $? |
11026
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
172 # Clean up debugging information left over by the native C compiler on MacOS X. |
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
173 rm -rf "$destprog.wrapper$exeext.dSYM" |
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
174 test $rc = 0 || exit $? |
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
175 |
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
176 # Strip wrapper. |
f7a9849b6394
Remove debugging information left over by C compiler on MacOS X.
Bruno Haible <bruno@clisp.org>
parents:
9548
diff
changeset
|
177 test "$strip_prog" = ':' || func_verbose "$strip_prog" "$destprog.wrapper$exeext" || exit $? |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
178 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
179 # Rename $destprog.wrapper -> $destprog -> $destprog.bin. |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
180 ln -f "$destprog$exeext" "$destprog.bin$exeext" \ |
8279 | 181 || { rm -f "$destprog.bin$exeext" \ |
182 && cp -p "$destprog$exeext" "$destprog.bin$exeext"; } \ | |
8265
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
183 || exit 1 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
184 mv "$destprog.wrapper$exeext" "$destprog$exeext" || exit 1 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
185 |
20006894dae4
Infrastructure for relocatable installation, from GNU gettext.
Bruno Haible <bruno@clisp.org>
parents:
diff
changeset
|
186 exit 0 |